module BlackStack
  module NextBot
    # This is the base model class.
    # From this class will inherit two classes:
    #
    # => The "local" (or persistance class) that
    # => will load, update and create records in 
    # => the database.
    #
    # => The "remote" (or API class) that will
    # => be receive the data from an API call.
    # 
    module BaseCommand
      TYPE_START_BOT = 100 # start browser. params: username 
      TYPE_LOGIN = 110 # login to account. param: social_media (LinkedIn, Facebook, Twitter) 
      TYPE_GOTO = 120 # param: url
      TYPE_TRAFFIC = 510
      #TYPE_FIND = 1
      #TYPE_MOUSE = 2
      #TYPE_WRITE = 3
      #TYPE_DELAY = 4
      #TYPE_CALL = 5
      #TYPE_IF = 6
      #TYPE_EXISTS = 7
      #TYPE_EACH = 8
      TYPE_CLOSE = 999 # close browser. params: n/a 
    
      STATUS_PENDING = 0
      STATUS_ONGOING = 1
      STATUS_FAILURE = 2
      STATUS_SUCCESS = 3
      STATUS_CANCELED = 4
    
      def self.types()
        [
          TYPE_START_BOT,
          TYPE_LOGIN,
          TYPE_GOTO,
          TYPE_TRAFFIC,
          #TYPE_FIND,
          #TYPE_MOUSE,
          #TYPE_WRITE,
          #TYPE_DELAY,
          #TYPE_CALL,
          #TYPE_IF,
          #TYPE_EXISTS,
          #TYPE_EACH,
          TYPE_CLOSE,
        ]
      end # self.types
      
      def self.statuses()
        [
          STATUS_PENDING,
          STATUS_ONGOING,
          STATUS_FAILURE,
          STATUS_SUCCESS,
          STATUS_CANCELED,          
        ]
      end
      
      def self.typeDescription(n)
        return "start" if n == TYPE_START_BOT
        return "login" if n == TYPE_LOGIN
        return "goto" if n == TYPE_GOTO
        return "traffic" if n == TYPE_TRAFFIC
        #return "find" if n == TYPE_FIND
        #return "mouse" if n == TYPE_MOUSE
        #return "write" if n == TYPE_WRITE
        #return "delay" if n == TYPE_DELAY
        #return "call" if n == TYPE_CALL
        #return "if" if n == TYPE_IF
        #return "exists" if n == TYPE_EXISTS
        #return "each" if n == TYPE_EACH
        return "close" if n == TYPE_CLOSE
        nil
      end # self.typeDescription

      def self.statusDescription(n)
        return "pending" if n == STATUS_PENDING
        return "ongoing" if n == STATUS_ONGOING
        return "failure" if n == STATUS_FAILURE
        return "success" if n == STATUS_SUCCESS
        return "canceled" if n == STATUS_CANCELED
        nil
      end # self.typeDescription

      def self.statusColor(n)
        return "orange" if n == STATUS_PENDING
        return "blue" if n == STATUS_ONGOING
        return "red" if n == STATUS_FAILURE
        return "green" if n == STATUS_SUCCESS
        return "black" if n == STATUS_CANCELED
        nil
      end # self.typeDescription

    end # module BaseCommand
  end # module NextBot
end # module BlackStack